package org.jeecg.modules.repair.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.repair.entity.BuMaDocument;
import org.jeecg.modules.repair.service.IBuMaDocumentService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

/**
* @Description: 文件管理
* @Author: jeecg-boot
* @Date:   2020-10-09
* @Version: V1.0
*/
@Api(tags="文件管理")
@RestController
@RequestMapping("/repair/buMaDocument")
@Slf4j
public class BuMaDocumentController extends JeecgController<BuMaDocument, IBuMaDocumentService> {
   @Autowired
   private IBuMaDocumentService buMaDocumentService;

   /**
    * 分页列表查询
    *
    * @param buMaDocument
    * @param pageNo
    * @param pageSize
    * @param req
    * @return
    */
   @AutoLog(value = "文件管理-分页列表查询")
   @ApiOperation(value="文件管理-分页列表查询", notes="文件管理-分页列表查询")
   @GetMapping(value = "/list")
   public Result<?> queryPageList(BuMaDocument buMaDocument,
                                  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
                                  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
                                  HttpServletRequest req) {
       QueryWrapper<BuMaDocument> queryWrapper = QueryGenerator.initQueryWrapper(buMaDocument, req.getParameterMap());
       Page<BuMaDocument> page = new Page<BuMaDocument>(pageNo, pageSize);
       IPage<BuMaDocument> pageList = buMaDocumentService.page(page, queryWrapper);
       return Result.OK(pageList);
   }

   /**
    *   添加
    *
    * @param buMaDocument
    * @return
    */
   @AutoLog(value = "文件管理-添加")
   @ApiOperation(value="文件管理-添加", notes="文件管理-添加")
   @PostMapping(value = "/add")
   public Result<?> add(@RequestBody BuMaDocument buMaDocument) {
       buMaDocumentService.save(buMaDocument);
       return Result.OK("添加成功！");
   }

   /**
    *  编辑
    *
    * @param buMaDocument
    * @return
    */
   @AutoLog(value = "文件管理-编辑")
   @ApiOperation(value="文件管理-编辑", notes="文件管理-编辑")
   @PutMapping(value = "/edit")
   public Result<?> edit(@RequestBody BuMaDocument buMaDocument) {
       buMaDocumentService.updateById(buMaDocument);
       return Result.OK("编辑成功!");
   }

   /**
    *   通过id删除
    *
    * @param id
    * @return
    */
   @AutoLog(value = "文件管理-通过id删除")
   @ApiOperation(value="文件管理-通过id删除", notes="文件管理-通过id删除")
   @DeleteMapping(value = "/delete")
   public Result<?> delete(@RequestParam(name="id",required=true) String id) {
       buMaDocumentService.removeById(id);
       return Result.OK("删除成功!");
   }

   /**
    *  批量删除
    *
    * @param ids
    * @return
    */
   @AutoLog(value = "文件管理-批量删除")
   @ApiOperation(value="文件管理-批量删除", notes="文件管理-批量删除")
   @DeleteMapping(value = "/deleteBatch")
   public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
       this.buMaDocumentService.removeByIds(Arrays.asList(ids.split(",")));
       return Result.OK("批量删除成功!");
   }

   /**
    * 通过id查询
    *
    * @param id
    * @return
    */
   @AutoLog(value = "文件管理-通过id查询")
   @ApiOperation(value="文件管理-通过id查询", notes="文件管理-通过id查询")
   @GetMapping(value = "/queryById")
   public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
       BuMaDocument buMaDocument = buMaDocumentService.getById(id);
       if(buMaDocument==null) {
           return Result.error("未找到对应数据");
       }
       return Result.OK(buMaDocument);
   }

   /**
   * 导出excel
   *
   * @param request
   * @param buMaDocument
   */
   @RequestMapping(value = "/exportXls")
   public ModelAndView exportXls(HttpServletRequest request, BuMaDocument buMaDocument) {
       return super.exportXls(request, buMaDocument, BuMaDocument.class, "文件管理");
   }

   /**
     * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
   @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
   public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
       return super.importExcel(request, response, BuMaDocument.class);
   }

}
